/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';

const agentEmitter = require('../../agent-emitter');
const { PATCH_TYPES } = require('../../constants');
const ModuleHook = require('../../hooks/require');
const patcher = require('../../hooks/patcher');
const logger = require('../logger')('contrast:arch-component');

ModuleHook.resolve({ name: 'rethinkdb' }, (rethinkdb) => {
  patcher.patch(rethinkdb, 'connect', {
    name: 'rethinkdb.arch_component',
    patchType: PATCH_TYPES.ARCH_COMPONENT,
    alwaysRun: true,
    post(ctx) {
      ctx.result
        .then((res) => {
          if (res.open) {
            const url =
              res.host == 'localhost'
                ? 'http://localhost'
                : new URL(res.host).toString();
            agentEmitter.emit('architectureComponent', {
              vendor: 'RethinkDB',
              url,
              remotePort: res.port,
            });
          } else {
            logger.warn('unable to open RethinkDB connection');
          }
        })
        .catch((err) => {
          logger.warn(
            'unable to report RethinkDB architecture component, err: %o',
            err,
          );
        });
    },
  });
});
